Require Import div_mod.
Require Import logic.
Require Import nat.
Require Import relations.
Definition congruent : nat.nat -> nat.nat -> nat.nat -> Prop := fun (n:nat.nat) => fun (m:nat.nat) => fun (p:nat.nat) => logic.eq (nat.nat) (div_mod.mod n p) (div_mod.mod m p).
Definition transitive_congruent : forall (p:nat.nat), relations.transitive (nat.nat) (fun (n:nat.nat) => fun (m:nat.nat) => congruent n m p) := fun (p:nat.nat) => fun (x:nat.nat) => fun (y:nat.nat) => fun (z:nat.nat) => fun (auto:congruent x y p) => (fun (auto':congruent y z p) => (((((((logic.rewrite_l) (nat.nat)) (div_mod.mod x p)) (fun (__:nat.nat) => logic.eq (nat.nat) (div_mod.mod x p) __)) (((logic.refl) (nat.nat)) (div_mod.mod x p))) (div_mod.mod z p)) (((((((logic.rewrite_r) (nat.nat)) (div_mod.mod y p)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (div_mod.mod z p))) (auto')) (div_mod.mod x p)) (auto)))).
